#include <string.h>
#include "crowbar.h"

CRB_ErrorDefinition crb_compile_error_message_format[] = {
    {"dummy", NULL},
    {"@G[($(token)t)", NULL},
    {"sȕ($(bad_char))", NULL},
    {"֐dĂ܂($(name))", NULL},
    {"sȃ}`oCgłB", NULL},
    {"K\ɉs܂܂Ă܂B", NULL},
    {"K\܂B$(message)", NULL},
    {"zÕChłB", NULL},
    {"z̗vffinalɂ͂ł܂B", NULL},
    {"Zqfinalɑ΂Ă͓Kpł܂B", NULL},
    {"dummy"}
};

CRB_ErrorDefinition crb_runtime_error_message_format[] = {
    {"dummy", NULL},
    {"ϐ܂͊֐܂($(name))B",
     "VariableNotFoundException"},
    {"֐vɑ΂AnĂ܂B",
     "ArgumentTooManyException"},
    {"֐vɑ΂AnĂȂ܂B",
     "ArgumentTooFewException"},
    {"boolean^łȂ΂Ȃ܂B",
     "NotBooleanException"},
    {"}CiXZq̃Iyh͐l^łȂ΂Ȃ܂B",
     "MinusOperandTypeException"},
    {"2Zq$(operator)̃Iyȟ^słB",
     "BadOperandTypeException"},
    {"&&, ||Zq̃IyhɎ^͎g܂B",
     "LogicalOperatorDoubleOperandException"},
    {"&&, ||Zq̃Iyhɐ^͎g܂B",
     "LogicalOperatorIntegerOperandException"},
    {"$(operator)Zqboolean^ɂ͎g܂B",
     "NotBooleanOperatorException"},
    {"nullɑ΂ēKpł鉉Z ==  != ł"
     "($(operator)͂ł܂)B",
     "NotNullOperatorException"},
    {"IyhӒlł͂܂B",
     "NotLValueException"},
    {"YZq̍Iyhzł͂܂B",
     "IndexOperandNotArrayException"},
    {"YZq̒ł͂܂B",
     "IndexOperandNotIntException"},
    {"z͈̔̓I[o[łB"
     "TCY$(size)̔z[$(index)]ANZXĂ܂B",
     "ArrayIndexOutOfBoundsException"},
    {"Ώۂ̃IuWFNgɂ$(method_name)Ƃ\bh͂܂B",
     "NoSuchMethodException"},
    {"CNg/fNg̑Ώۂł͂܂B",
     "IncDecOperandTypeException"},
    {"CNg/fNg̑Ώۂ݂܂B",
     "IncDecOperandNotExistException"},
    {"֐ĂяȏΏۂ֐ł͂܂B",
     "NotFunctionException"},
    {"IuWFNgȊÕo͍XVł܂B",
     "NotObjectMemberUpdateException"},
    {"IuWFNgȊÕoɂ͑͂ł܂B",
     "NotObjectMemberAssignException"},
    {"̃IuWFNgɂ̓o$(member_name)͂܂B",
     "NoSuchMemberException"},
    {"̃f[^^ɂ̓ô͍Ƃ날܂B",
     "NoMemberTypeException"},
    {"ɑ΂Zq$(operator)͓Kpł܂B",
     "BadOperatorForStringException"},
    {"[ŏZ͂ł܂B",
     "DivisionByZeroException"},
    {"O[oϐ$(name)݂͑܂B",
     "GlobalVariableNotFoundException"},
    {"global͊֐Oł͎g܂B",
     "GlobalStatementInToplevelException"},
    {"$(name)ƂO̊֐ɑ݂܂B",
     "FunctionExistsException"},
    {"zresize()̈͐^łȂ΂Ȃ܂"
     "($(type)nĂ܂)B",
     "ArrayResizeArgumentException"},
    {"zinsert()̑1͐^łȂ΂Ȃ܂"
     "($(type)nĂ܂)B",
     "ArrayInsertArgumentException"},
    {"zremove()̈͐^łȂ΂Ȃ܂"
     "($(type)nĂ܂)B",
     "ArrayRemoveArgumentException"},
    {"񒆂̈ʒuw肪͈͊OłB"
     "$(len)̕ɑ΂$(pos)w肵Ă܂B",
     "StringPositionOutOfBoundsException"},
    {"substr()̑2(؂o)͈͊O($(len))łB",
     "StringSubstrLengthException"},
    {"substr()̈͐^łȂ΂Ȃ܂"
     "($(type1)$(type2)nĂ܂)B",
     "StringSubstrArgumentException"},
    {"Omessageo܂B",
     "ExceptionHasNoMessageException"},
    {"Omessageoł͂܂($(type)nĂ܂)B",
     "ExceptionMessageIsNotStringException"},
    {"Ostack_traceo܂B",
     "ExceptionHasNoStackTraceException"},
    {"ÕX^bNg[Xz^ł͂܂B",
     "StackTraceIsNotArrayException"},
    {"ÕX^bNg[X̗vfIuWFNgł͂܂B",
     "StackTraceLineIsNotAssocException"},
    {"X^bNg[X̍sɍsԍ܂܂܂B",
     "StackTraceLineHasNoLineNumberException"},
    {"X^bNg[X̍sɊ֐܂܂܂B",
     "StackTraceLineHasNoFuncNameException"},
    {"IuWFNgȊO̗Ogbvx܂œ`d܂B",
     "ExceptionIsNotAssocException"},
    {"Oprint_stack_traceo܂B",
     "ExceptionHasNoPrintStackTraceMethodException"},
    {"Oprint_stack_traceoN[Wł͂܂B",
     "PrintStackTraceIsNotClosureException"},
    {"sȃ}`oCgłB",
     "BadMultibyteCharacterException"},
    {"ONXIuWFNgł͂܂($(type)ł)B",
     "ExceptionClassIsNotAssocException"},
    {"ONXcreate method܂B",
     "ExceptionClassHasNoCreateMethodException"},
    {"֐$(func_name)ɓnĂ$(idx)Ԗڂ̈̌^Ⴂ܂B"
     "$(type)nĂ܂B",
     "ArgumentTypeMismatchException"},
    {"zÕChłB",
     "UnexpectedWideStringException"},
    {"K\ɂ錟Ɏs܂B$(message)",
     "OnigSearchFailException"},
    {"K\̃O[vԍ傫܂B",
     "GroupIndexOverflowException"},
    {"w肳ꂽO[vԍ(\\$(g_idx))ɑΉO[v͂܂B",
     "GroupIndexOverflowException"},
    {"break܂continue܂returngbvx܂œ`d܂B",
     "BreakOrContinueReachedToplevelException"},
    {"ϐ܂̓o$(name)finalłB",
     "AssignToFinalVariableException"},
    {"֐܂($(name))B",
     "FunctionNotFoundException"},
    {"dummy", NULL}
};

CRB_ErrorDefinition crb_native_error_message_format[] = {
    {"fopen()֐ɂ̓t@C̃pXƃ[h(ǂ^)"
     "nĂB",
     "FOpenArgumentTypeException"},
    {"fclose()֐ɂ̓t@C|C^nĂB",
     "FCloseArgumentTypeException"},
    {"fgets()֐ɂ̓t@C|C^nĂB",
     "FGetsArgumentTypeException"},
    {"̃t@C͊ɃN[YĂ܂B",
     "FileAlreadyClosedException"},
    {"fputs()֐ɂ̓t@C|C^ƕnĂB",
     "FPutsArgumentTypeException"},
    {"new_array()֐ɂ͐^(zTCY)nĂB",
     "NewArrayArgumentTypeException"},
    {"new_array()֐ɂ́Az̃TCY̐nĂB",
     "NewArrayArgumentTooFewException"},
    {"exit()̈͐^łȂ΂Ȃ܂"
     "($(type)nĂ܂)B",
     "ExitArgumentTypeException"},
    {"new_exception()̈̓bZ[Wł"
     "($(type)nĂ܂)B",
     "NewExceptionArgumentException"},
    {"sȃ}`oCgłB",
     "FGetsBadMultibyteCharacterException"},
};
